From 01ca9b795321cb0b5252aa4de71b9a9269991fbf Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Thu, 30 Jul 2020 03:44:55 +0300
Subject: [PATCH 33/59] AlpineApkResource: AppStream integration

return some data from appstream metadata, if available
---
 .../AlpineApkBackend/AlpineApkResource.cpp    | 136 +++++++++++++++++-
 .../AlpineApkBackend/AlpineApkResource.h      |  13 +-
 2 files changed, 141 insertions(+), 8 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkResource.h b/libdiscover/backends/AlpineApkBackend/AlpineApkResource.h
index 7140786c5..e8948c467 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkResource.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkResource.h
@@ -23,6 +23,7 @@
 
 #include <resources/AbstractResource.h>
 #include <QtApkPackage.h>
+#include <AppStreamQt/component.h>
 
 class AddonList;
 
@@ -31,7 +32,10 @@ class AlpineApkResource : public AbstractResource
     Q_OBJECT
 
 public:
-    explicit AlpineApkResource(const QtApk::Package &apkPkg, AbstractResourcesBackend *parent);
+    explicit AlpineApkResource(const QtApk::Package &apkPkg,
+                               AppStream::Component &component,
+                               AbstractResource::Type typ,
+                               AbstractResourcesBackend *parent);
 
     QList<PackageState> addonsInformation() override;
     QString section() override;
@@ -52,10 +56,11 @@ public:
     QString name() const override;
     QString packageName() const override;
     AbstractResource::Type type() const override { return m_type; }
-    bool canExecute() const override { return true; }
+    bool canExecute() const override;
     void invokeApplication() const override;
     void fetchChangelog() override;
     void fetchScreenshots() override;
+    QString appstreamId() const override;
     QUrl url() const override;
     QString author() const override;
     QString sourceIcon() const override;
@@ -69,6 +74,9 @@ public:
     void setAddonInstalled(const QString &addon, bool installed);
     void setAvailableVersion(const QString &av);
 
+private:
+    bool hasAppStreamData() const;
+
 public:
     AbstractResource::State m_state;
     const AbstractResource::Type m_type;
@@ -78,6 +86,7 @@ public:
     QString m_originSoruce;
     QString m_sectionName;
     QList<PackageState> m_addons;
+    AppStream::Component m_appsC;
 };
 
 #endif // ALPINEAPKRESOURCE_H
-- 
GitLab


